<?php

namespace App\Modules\DefinedService\TypeDefinedService\Application\Index;

use App\Modules\DefinedService\TypeDefinedService\Application\TypeDefinedServiceResponse;
use App\Modules\DefinedService\TypeDefinedService\Domain\IdTypeDefinedService;
use App\Modules\Shared\Domain\Bus\Query\QueryHandler;

final class IndexTypeDefinedServiceQueryHandler implements QueryHandler
{
    public function __construct(private TypeDefinedServiceIndexer $inserter) {}

    public function __invoke(IndexTypeDefinedServiceQuery $query): TypeDefinedServiceResponse
    {
        $model = $this->inserter->__invoke(new IdTypeDefinedService($query->getId()));
        return new TypeDefinedServiceResponse(
            $model->id()->value(),
            $model->date()->value(),
            $model->dateUpdate()->value(),
            $model->name()->value(),
            $model->code()->value(),
            $model->version()->value(),
            $model->status()->value(),
            $model->idTypeProvider()->value()
        );
    }
}
